  program main

  use parallel_m
  use particle_m
  use rules_m
  use io_m
  use in_situ_m

  implicit none

  integer ierr
  real    dt
  real    simtime
  logical simcond

  ! Start parallel processes
  call initialize()

  ! Read initial conditions
  ierr = read_particles( 'particle_m.dat' )
  if ( ierr .ne. 0 ) goto 90

  ! Read boundary conditions, step size, termination conditions, etc.
  ierr = read_rules( 'rules_m.dat' )
  if ( ierr .ne. 0 ) goto 90
  
  simtime = 0.
  simstep = 0
  dt = .1
  call in_situ_init()
  !call write_state( 'psim_' )

  ! Simulation loop:
10  call advance_particles( dt )
    call in_situ_step( simtime )
    simcond = evaluate_exit_condition( dt )
    simtime = simtime + dt
    simstep = simstep + 1
    call write_state( 'psim_' )
    if ( simcond ) goto 90

  goto 10

  ! finalize
9   format( 'Took ', i4, ' steps' )
90  if ( local_id .eq. 0 ) write (*,9) simstep

  ! Shut down in situ analysis
  call in_situ_fini()
  ! Stop parallel processes
  call finalize()

  end
